!/*
! * SocketTools Library Edition
! * Version 3.0
! *
! * Copyright 1995-1999, Catalyst Development Corporation
! * All rights reserved
! *
! * This module contains the confidential and proprietary information
! * of Catalyst Development Corporation and may not be redistributed.
! *
! * This product is licensed to you pursuant to the terms of the
! * Catalyst license agreement included with the original software,
! * and is protected by copyright law and international treaties.
! * Unauthorized reproduction or distribution may result in severe
! * criminal penalties.
! */

!***************************************************************************
! Notes for the Clarion Conversion
!
! This document is being distributed with the permission of
! Catalyst Development Corporation.
!
! The C prototypes have been left in place for reference in debugging
! and to facilitate the learning process for those Clarion programmers
! who are unfamiliar with C.
!
! Each block of prototypes begins with the commented C version, followed
! by the Clarion prototypes
!
! The proverbial disclaimer:
!
! This C to CW conversion is being offered as service to the Clarion
! developer community. As such, none of the contributors make any assurance
! that this code will work for you. There may be errors and omissions. If
! you find an error or omission, you are encouraged to fix it, test your fix
! and contribute your *tested* fix for inclusion in a future release.
!
! A special note of thanks to Jeff Slarve. Jeff's generous contribution to
! this project saved MUCH time and effort in bringing it to completion.
!
! Initial conversion to Clarion by: Mark Geisinger
! POP3 courtesy of Greg Palmer by way of Jeff Slarve
! Comments or corrections may be sent to: critters@bugsbugme.com
! Initial public release:   09/20/1998
! Updated:                  09/22/1998
!    Added the readme.txt file. See that file for release notes and
!    usage information.
!***************************************************************************
    Program
SOCKET  equate(unsigned)

!#ifndef _CSTOOLS_CSTYPES_H
!#define _CSTOOLS_CSTYPES_H

!#ifdef __cplusplus
!extern "C" {
!#endif

!#if defined(_MSC_VER) && !defined(RC_INVOKED)
!#ifdef WIN32
!#pragma pack(8)
!#else
!#pragma pack(2)
!#endif
!#endif

!#ifndef PUBLIC
!#define PUBLIC extern
!#endif

!#ifndef GLOBAL
!#define GLOBAL
!#endif

!#ifndef PRIVATE
!#define PRIVATE static
!#endif

!#ifndef WIN32
!#define HUGE _huge
!#else
!#define HUGE
!#endif

!typedef unsigned long ULONG;
!typedef unsigned short USHORT;

USHORT  equate(unsigned)

!typedef unsigned int HBROWSER;
!typedef unsigned int HCLIENT;
!typedef unsigned int HCONNECTION;
!typedef unsigned int HDISPLAY;
!typedef unsigned int HDOCUMENT;
!typedef unsigned int HMESSAGE;
!typedef unsigned int HMESSAGEPART;
!typedef unsigned int HRESOURCE;

HBROWSER        equate(unsigned)
HCLIENT         equate(unsigned)
HCONNECTION     equate(unsigned)
HDISPLAY        equate(unsigned)
HDOCUMENT       equate(unsigned)
HMESSAGE        equate(unsigned)
HMESSAGEPART    equate(unsigned)
HRESOURCE       equate(unsigned)

!#define INVALID_CLIENT          ((HCLIENT)(~0))
!#define INVALID_DISPLAY         ((HDISPLAY)(~0))
!#define INVALID_IMAGE           ((HANDLE)NULL)
!#define INVALID_MESSAGE         ((HMESSAGE)(~0))
!#define INVALID_MESSAGEPART     ((HMESSAGEPART)(~0))

INVALID_CLIENT          equate(0FFFFFFFFh)
INVALID_DISPLAY         equate(0FFFFFFFFh)
INVALID_IMAGE           equate(0)
INVALID_MESSAGE         equate(0FFFFFFFFh)
INVALID_MESSAGEPART     equate(0FFFFFFFFh)

!typedef struct _ICMPTIME
!{
!    DWORD dwTripAverage;
!    DWORD dwTripMaximum;
!    DWORD dwTripMinimum;
!    DWORD dwTripTime;
!} ICMPTIME, FAR *LPICMPTIME;

_ICMPTIME   group, type
dwTripAverage    ulong
dwTripMaximum    ulong
dwTripMinimum    ulong
dwTripTime       ulong
end

LPICMPTIME  equate(ulong)

!typedef struct _NVTDISPLAYINFO
!{
!    HWND    hWnd;
!    HFONT   hFont;
!    int     xPos;
!    int     yPos;
!    int     cxClient;
!    int     cyClient;
!    int     cxChar;
!    int     cyChar;
!    int     nScrollCol;
!    int     nScrollRow;
!    int     nMaxScrollCol;
!    int     nMaxScrollRow;
!} NVTDISPLAYINFO, FAR* LPNVTDISPLAYINFO;

_NVTDISPLAYINFO group, type
hWnd               ulong
hFont              ulong
xPos               signed
yPos               signed
cxClient           signed
cyClient           signed
cxChar             signed
cyChar             signed
nScrollCol         signed
nScrollRow         signed
nMaxScrollCol      signed
nMaxScrollRow      signed
end

LPNVTDISPLAYINFO    equate(ulong)

!#ifndef WIN32
!typedef struct _SYSTEMTIME
!{
!    WORD wYear;
!    WORD wMonth;
!    WORD wDayOfWeek;
!    WORD wDay;
!    WORD wHour;
!    WORD wMinute;
!    WORD wSecond;
!    WORD wMilliseconds;
!} SYSTEMTIME, FAR *LPSYSTEMTIME;
!#endif

_SYSTEMTIME group, type
wYear           signed
wMonth          signed
wDayOfWeek      signed
wDay            signed
wHour           signed
wMinute         signed
wSecond         signed
wMilliseconds   signed
end
!#if defined(_MSC_VER) && !defined(RC_INVOKED)
!#pragma pack()
!#endif

!/*
! * The DLLVERSIONINFO structure is returned by the DllGetVersion function
! * exported from the DLLs and controls. This packed data structure is
! * normally defined in shlwapi.h (available from the Microsoft Platform
! * SDK since November, 1997).
! *
! * Note that we also export this function from our 16-bit DLLs and
! * controls. The platform ID will always be DLLVER_PLATFORM_WINDOWS
! * since we support all versions of Windows.
! */
!#ifndef DLLVER_PLATFORM_WINDOWS
!#if defined(_MSC_VER) && !defined(RC_INVOKED)
!#pragma pack(1)
!#endif

!typedef struct _DLLVERSIONINFO
!{
!    DWORD cbSize;
!    DWORD dwMajorVersion;
!    DWORD dwMinorVersion;
!    DWORD dwBuildNumber;
!    DWORD dwPlatformID;
!} DLLVERSIONINFO, FAR *LPDLLVERSIONINFO;

_DLLVERSIONINFO     group, type
bSize           ulong
wMajorVersion   ulong
wMinorVersion   ulong
wBuildNumber    ulong
wPlatformID     ulong
end


!typedef DWORD (CALLBACK* DLLGETVERSIONPROC)(LPDLLVERSIONINFO);

!#define DLLVER_PLATFORM_WINDOWS         0x00000001
!#define DLLVER_PLATFORM_NT              0x00000002

DLLVER_PLATFORM_WINDOWS         equate(00000001h)
DLLVER_PLATFORM_NT              equate(00000002h)

!#if defined(_MSC_VER) && !defined(RC_INVOKED)
!#pragma pack()
!#endif
!#endif

!#ifdef __cplusplus
!}
!#endif
!#endif /* _CSTOOLS_CSTYPES_H */